; A COMPREHENSIVE DISASSEMBLY OF SUPER MARIO BROS. 2
; by Beneficii
; Special thanks to Doppelganger for letting me steal his labels
; and to loopy and others for their work
; Assembles with loopy's asm6

.include "defines.inc"

PRAM = $00                      ;File loads into PRG-RAM
CRAM = $01                      ;File loads into CHR-RAM
VRAM = $02                      ;File loads into VideoRAM

$ = $0000                       ;start writing to file

;FDS header (feel free to comment out if not want)
.byte "FDS", $1a, 1             ;basic header things (indicating just one disk)
.pad 16, 0                      ;fill rest of header with 0's

headeradder = $

;-------------------------------------------------------------------------------
; Disk Header Block

.byte 1                         ;start of disk header block
.byte "*NINTENDO-HVC*"          ;Nintendo's header verification check
.byte 1, "SMB ", 0, 0, 0, 0, 0  ;manufacture codes and game name
.byte $f                        ;boot disk ID (all File ID's less than or equal 
                                ;to this are loaded at system boot)
.byte 255,255,255,255,255       ;unknown
.byte $61, $07, $23             ;product date in BCD using Showa years (+1925)
.byte $49, $61, $00, $00, $02   ;unknown
.byte $00, $1b, $00, $97, $00   ;unknown
.byte $61, $07, $23             ;create date in BCD using Showa years (+1925)
.byte 255,255,255,255,255       ;unknown
.byte $00, $00, $00, $00        ;unknown

;-------------------------------------------------------------------------------
; File Amount Block

.byte 2                         ;start of file amount block
.byte 8                         ;8 number of files

;-------------------------------------------------------------------------------
; File "KYODAKU-"

;File Header
.byte 3                         ;start of file header block
.byte 0, 0, "KYODAKU-"          ;File Number, File ID, and Filename
.word FDS_ConsentMsg_Start      ;starting address
.word END_KYODAKU_ - KYODAKU_   ;size of file
.byte VRAM                      ;file loads into video RAM

;File Block
.byte 4                         ;start of file block

KYODAKU_:
.incbin "kyodaku-.bin"          ;include file
END_KYODAKU_

;-------------------------------------------------------------------------------
; File "SM2CHAR1"

;File Header
.byte 3                         ;start of file header block
.byte 1, 1, "SM2CHAR1"          ;File Number, File ID, and Filename
.word FDS_CRAM_Start            ;starting address
.word END_SM2CHAR1 - SM2CHAR1   ;size of file
.byte CRAM                      ;file loads into CHR-RAM

;File Block
.byte 4                         ;start of file block

SM2CHAR1:
.incbin "sm2char1.bin"          ;include file
END_SM2CHAR1

;-------------------------------------------------------------------------------
; File "SM2CHAR2"

;File Header
.byte 3                         ;start of file header block
.byte 2, $10, "SM2CHAR2"        ;File Number, File ID, and Filename
.word PrincessDoorData          ;starting address
.word END_SM2CHAR2 - SM2CHAR2   ;size of file
.byte CRAM                      ;file loads into CHR-RAM

;File Block
.byte 4                         ;start of file block

SM2CHAR2:
.incbin "sm2char2.bin"          ;include file
END_SM2CHAR2

;-------------------------------------------------------------------------------
; File "SM2MAIN "

;File Header
.byte 3                         ;start of file header block
.byte 3, 5, "SM2MAIN "          ;File Number, File ID, and Filename
.word FDS_PRAM_Start            ;starting address
.word END_SM2MAIN_ - SM2MAIN_   ;size of file
.byte PRAM                      ;file loads into PRG-RAM

;File Block
.byte 4                         ;start of file block

disk_total = $
$ = FDS_PRAM_Start
SM2MAIN_:
.include "sm2main_.asm"         ;include file
END_SM2MAIN_
$ = disk_total + END_SM2MAIN_ - SM2MAIN_

;-------------------------------------------------------------------------------
; File "SM2DATA2"

;File Header
.byte 3                         ;start of file header block
.byte 4, $20, "SM2DATA2"        ;File Number, File ID, and Filename
.word $c470                     ;starting address
.word END_SM2DATA2 - SM2DATA2   ;size of file
.byte PRAM                      ;file loads into PRG-RAM

;File Block
.byte 4                         ;start of file block

disk_total = $
$ = $c470
SM2DATA2:
.include "sm2data2.asm"         ;include file
END_SM2DATA2
$ = disk_total + END_SM2DATA2 - SM2DATA2

;-------------------------------------------------------------------------------
; File "SM2DATA3"

;File Header
.byte 3                         ;start of file header block
.byte 5, $30, "SM2DATA3"        ;File Number, File ID, and Filename
.word $c5d0                     ;starting address
.word END_SM2DATA3 - SM2DATA3   ;size of file
.byte PRAM                      ;file loads into PRG-RAM

;File Block
.byte 4                         ;start of file block

disk_total = $
$ = $c5d0
SM2DATA3:
.include "sm2data3.asm"         ;include file
END_SM2DATA3
$ = disk_total + END_SM2DATA3 - SM2DATA3

;-------------------------------------------------------------------------------
; File "SM2DATA4"

;File Header
.byte 3                         ;start of file header block
.byte 6, $40, "SM2DATA4"        ;File Number, File ID, and Filename
.word FindAreaPointer           ;starting address
.word END_SM2DATA4 - SM2DATA4   ;size of file
.byte PRAM                      ;file loads into PRG-RAM

;File Block
.byte 4                         ;start of file block

disk_total = $
$ = FindAreaPointer
SM2DATA4:
.include "sm2data4.asm"         ;include file
END_SM2DATA4
$ = disk_total + END_SM2DATA4 - SM2DATA4

;-------------------------------------------------------------------------------
; File "SM2SAVE "

;File Header
.byte 3                         ;start of file header block
.byte 7, $0f, "SM2SAVE "        ;File Number, File ID, and Filename
.word NbrGamesWon               ;starting address
.word EndSave - NbrGamesWon     ;size of file
.byte PRAM                      ;file loads into PRG-RAM

;File Block
.byte 4                         ;start of file block

.byte 8                         ;just this one byte (indicating no games won)

;-------------------------------------------------------------------------------
; The End of Disk
.byte $ff                       ;start of ending block
.pad  65500 + headeradder, 0    ;fill rest of disk with 0's


