

FindAreaPointerB:
	ldy WorldNumber
	lda WorldAddrOffsetsB,y
	clc
	adc AreaNumber
	tay
	lda AreaAddrOffsetsB,y
	rts

GetAreaDataAddrsB:
	lda AreaPointer
	jsr GetAreaType
	tay
	lda AreaPointer
	and #%00011111
	sta AreaAddrsOffset
	lda EnemyDataHOffsetsB,y
	clc
	adc AreaAddrsOffset
	asl
	tay
	lda EnemyDataOffsetsB+1,y
	sta EnemyDataHigh
	lda EnemyDataOffsetsB,y
	sta EnemyDataLow
	ldy AreaType
	lda AreaDataHOffsetsB,y
	clc
	adc AreaAddrsOffset
	asl
	tay
	lda AreaDataOffsetsB+1,y
	sta AreaDataHigh
	lda AreaDataOffsetsB,y
	sta AreaDataLow
	ldy #$00
	lda (AreaData),y
	pha
	and #%00000111
	cmp #%00000100
	bcc StoreForeB
	sta BackgroundColorCtrl
	lda #$00
StoreForeB:
	sta ForegroundScenery
	pla
	pha
	and #%00111000
	lsr
	lsr
	lsr
	sta PlayerEntranceCtrl
	pla
	and #%11000000
	clc
	rol
	rol
	rol
	sta GameTimerSetting
	iny
	lda (AreaData),y
	pha
	and #%00001111
	sta TerrainControl
	pla
	pha
	and #%00110000
	lsr
	lsr
	lsr
	lsr
	sta BackgroundScenery
	pla
	and #%11000000
	clc
	rol
	rol
	rol
	cmp #%00000011
	bne StoreStyleB
	sta CloudTypeOverride
	lda #$00
StoreStyleB:
	sta AreaStyle
	lda AreaDataLow
	clc
	adc #$02
	sta AreaDataLow
	lda AreaDataHigh
	adc #$00
	sta AreaDataHigh
	rts

;-------------------------------------------------------------------------------------
;GAME LEVELS DATA (for worlds A-D)

WorldAddrOffsetsB:

	.byte WorldAAreas-AreaAddrOffsetsB, WorldBAreas-AreaAddrOffsetsB
	.byte WorldCAreas-AreaAddrOffsetsB, WorldDAreas-AreaAddrOffsetsB
    
	.byte $00, $00, $00, $00, $00                  ;unused
	
AreaAddrOffsetsB:
WorldAAreas:
	.byte $20, $2c, $40, $21, $60
	
WorldBAreas:
	.byte $22, $2c, $00, $23, $61
	
WorldCAreas:
	.byte $24, $25, $26, $62
	
WorldDAreas:
	.byte $27, $28, $29, $63
	
EnemyDataHOffsetsB:	
	.byte (E_WaterAreasB-EnemyDataOffsetsB)>>1, (E_GroundAreasB-EnemyDataOffsetsB)>>1
	.byte (E_UndergroundAreasB-EnemyDataOffsetsB)>>1, (E_CastleAreasB-EnemyDataOffsetsB)>>1

EnemyDataOffsetsB:
E_CastleAreasB:
	.word E_A4, E_B4, E_C4, E_D4
	
E_GroundAreasB:
	.word E_A1, E_A3, E_B1, E_B3, E_C1, E_C2, E_C3, E_D1, E_D2, E_D3
	.word E_D4_Outside, E_AD_Cloud, E_PipeIntro, E_OverworldExit
	
E_UndergroundAreasB:
	.word E_A2, E_AD_Bonus
	
E_WaterAreasB:
	.word E_B2

AreaDataHOffsetsB:
	.byte (L_WaterAreasB-AreaDataOffsetsB)>>1, (L_GroundAreasB-AreaDataOffsetsB)>>1
	.byte (L_UndergroundAreasB-AreaDataOffsetsB)>>1, (L_CastleAreasB-AreaDataOffsetsB)>>1

AreaDataOffsetsB:
L_CastleAreasB:
	.word L_A4, L_B4, L_C4, L_D4
	
L_GroundAreasB:
	.word L_A1, L_A3, L_B1, L_B3, L_C1, L_C2, L_C3, L_D1, L_D2, L_D3
	.word L_D4_Outside, L_AD_Cloud, L_PipeIntro, L_OverworldExit
	
L_UndergroundAreasB:
	.word L_A2, L_AD_Bonus
	
L_WaterAreasB:
	.word L_B2

HalfwayPageNybblesB:	
	.byte $76, $50
	.byte $65, $50
	.byte $75, $b0
	.byte $00, $00
	
LoadHalfwayPageNybblesB:
	ldy #$07
LoadHalfwayLoop:
	lda HalfwayPageNybblesB,y
	sta HalfwayPageNybbles,y
	dey
	bpl LoadHalfwayLoop
	rts

    .pad $c470

	lda #$01
	pha
	bne $c478
	lda #$04
	pha
	jsr $7761
	pla
	sta $07
	tya
	pha
	ldy $0730,x
	beq $c4a8
	jsr $7791
	bcs $c4a8
	lda #$04
	jsr $7772
	lda $06
	asl
	asl
	asl
	asl
	clc
	adc $cf,x
	sec
	sbc #$0a
	sta $cf,x
	sta $0434,x
	clc
	adc #$18
	sta $0417,x
	inc $a0,x
	pla
	tay
	pha
	ldx $07
	lda $772b,y
	ldy $06
	dey
	jsr $79c6
	pla
	tay
	lda $7729,y
	sta $06a1,x
	rts

	rts

	lda $1e,x
	bne $c4fd
	lda $078a,x
	bne $c4fd
	lda $a0,x
	bne $c4d8
	lda $58,x
	eor #$ff
	clc
	adc #$01
	sta $58,x
	inc $a0,x
	lda $0417,x
	ldy $58,x
	bpl $c4e2
	lda $0434,x
	sta $00
	lda $0747
	bne $c4fd
	lda $cf,x
	clc
	adc $58,x
	sta $cf,x
	cmp $00
	bne $c4fd
	lda #$00
	sta $a0,x
	lda #$20
	sta $078a,x
	rts

	lda $07f9
	beq $c52b
	lda $074e
	cmp #$01
	bne $c52b
	ldy #$01
	lda $09
	asl
	bcs $c513
	ldy #$03
	sty $00
	lda $09
	and $00
	bne $c52b
	lda $86
	clc
	adc #$01
	sta $86
	lda $6d
	adc #$00
	sta $6d
	inc $06ff
	rts

	.byte $30
	.byte $70
	.byte $b8
	.byte $50
	.byte $98
	.byte $30
	.byte $70
	.byte $b8
	.byte $50
	.byte $98
	.byte $30
	.byte $70
	.byte $30
	.byte $30
	.byte $30
	.byte $60
	.byte $60
	.byte $a0
	.byte $a0
	.byte $a0
	.byte $d0
	.byte $d0
	.byte $d0
	.byte $60
	.byte $7b
	.byte $7b
	.byte $7b
	.byte $7b
	.byte $7a
	.byte $7a
	.byte $7b
	.byte $7b
	.byte $7b
	.byte $7a
	.byte $7b
	.byte $7a
	lda $07f9
	beq $c588
	lda #$04
	sta $fd
	jsr $c5a1
	ldx #$00
	ldy $06eb
	lda $c52c,x
	sta $0200,y
	lda $c544,x
	sta $0201,y
	lda #$41
	sta $0202,y
	lda $c538,x
	sta $0203,y
	iny
	iny
	iny
	iny
	inx
	cpx #$06
	bne $c584
	ldy $06ec
	cpx #$0c
	bne $c561
	rts

	.byte $57
	.byte $57
	.byte $56
	.byte $56
	.byte $58
	.byte $58
	.byte $56
	.byte $56
	.byte $57
	.byte $58
	.byte $57
	.byte $58
	.byte $59
	.byte $59
	.byte $58
	.byte $58
	.byte $5a
	.byte $5a
	.byte $58
	.byte $58
	.byte $59
	.byte $5a
	.byte $59
	.byte $5a
	ldx #$0b
	lda $c538,x
	clc
	adc $c589,x
	adc $c589,x
	sta $c538,x
	lda $c52c,x
	clc
	adc $c589,x
	sta $c52c,x
	dex
	bpl $c5a3
	rts

	lda #$01
	bne $c5c4
	lda #$00
	sta $07f9
	rts

	.align $10
	
;Worlds A-D Enemy Data
E_A4:
	.byte $2a, $9e, $6b, $0c, $8d, $1c, $ea, $1f, $1b, $8c
	.byte $e6, $1c, $8c, $9c, $bb, $0c, $f3, $83, $9b, $8c
	.byte $db, $0c, $1b, $8c, $6b, $0c, $bb, $0c, $0f, $09
	.byte $40, $15, $78, $ad, $90, $b5, $ff

E_B4:
	.byte $0f, $02, $38, $1d, $d9, $1b, $6e, $e1, $21, $3a
	.byte $a8, $18, $9d, $0f, $07, $18, $1d, $0f, $09, $18
	.byte $1d, $0f, $0b, $18, $1d, $7b, $15, $8e, $21, $2e
	.byte $b9, $9d, $0f, $0e, $78, $2d, $90, $b5, $ff

E_C4:
	.byte $05, $9d, $65, $1d, $0d, $a8, $dd, $1d, $07, $ac
	.byte $54, $2c, $a2, $2c, $f4, $2c, $42, $ac, $26, $9d
	.byte $d4, $03, $24, $83, $64, $03, $2b, $82, $4b, $02
	.byte $7b, $02, $9b, $02, $5b, $82, $7b, $02, $0b, $82
	.byte $2b, $02, $c6, $1b, $28, $82, $48, $02, $a6, $1b
	.byte $7b, $95, $85, $0c, $9d, $9b, $0f, $0e, $78, $2d
	.byte $7a, $1d, $90, $b5, $ff

E_D4:
	.byte $19, $9f, $99, $1b, $2c, $8c, $59, $1b, $c5, $0f
	.byte $0f, $04, $09, $29, $bd, $1d, $0f, $06, $6e, $2a
	.byte $61, $0f, $09, $48, $2d, $46, $87, $79, $07, $8e
	.byte $63, $60, $a5, $07, $b8, $85, $57, $a5, $8c, $8c
	.byte $76, $9d, $78, $2d, $90, $b5, $ff

E_A1:
	.byte $07, $83, $37, $03, $6b, $0e, $e0, $3d, $20, $be
	.byte $6e, $2b, $00, $a7, $85, $d3, $05, $e7, $83, $24
	.byte $83, $27, $03, $49, $00, $59, $00, $10, $bb, $b0
	.byte $3b, $6e, $c1, $00, $17, $85, $53, $05, $36, $8e
	.byte $76, $0e, $b6, $0e, $e7, $83, $63, $83, $68, $03
	.byte $29, $83, $57, $03, $85, $03, $b5, $29, $ff

E_A3:
	.byte $0f, $04, $66, $07, $0f, $06, $86, $10, $0f, $08
	.byte $55, $0f, $e5, $8f, $ff

E_B1:
	.byte $70, $b7, $ca, $00, $66, $80, $0f, $04, $79, $0e
	.byte $ab, $0e, $ee, $2b, $20, $eb, $80, $40, $bb, $fb
	.byte $00, $40, $b7, $cb, $0e, $0f, $09, $4b, $00, $76
	.byte $00, $d8, $00, $6b, $8e, $73, $06, $83, $06, $c7
	.byte $0e, $36, $90, $c5, $06, $ff

E_B3:
	.byte $84, $8f, $a7, $24, $d3, $0f, $ea, $24, $45, $a9
	.byte $d5, $28, $45, $a9, $84, $25, $b4, $8f, $09, $90
	.byte $b5, $a8, $5b, $97, $cd, $28, $b5, $a4, $09, $a4
	.byte $65, $28, $92, $90, $e3, $83, $ff

E_C1:
	.byte $3a, $8e, $5b, $0e, $c3, $8e, $ca, $8e, $0b, $8e
	.byte $4a, $0e, $de, $c1, $44, $0f, $08, $49, $0e, $eb
	.byte $0e, $8a, $90, $ab, $85, $0f, $0c, $03, $0f, $2e
	.byte $2b, $40, $67, $86, $ff

E_C2:
	.byte $15, $8f, $54, $07, $aa, $83, $f8, $07, $0f, $04
	.byte $14, $07, $96, $10, $0f, $07, $95, $0f, $9d, $a8
	.byte $0b, $97, $09, $a9, $55, $24, $a9, $24, $bb, $17
	.byte $ff

E_C3:
	.byte $0f, $03, $a6, $11, $a3, $90, $a6, $91, $0f, $08
	.byte $a6, $11, $e3, $a9, $0f, $0d, $55, $24, $a9, $24
	.byte $0f, $11, $59, $1d, $a9, $1b, $23, $8f, $15, $9b
	.byte $ff

E_D1:
	.byte $87, $85, $9b, $05, $18, $90, $a4, $8f, $6e, $c1
	.byte $60, $9b, $02, $d0, $3b, $80, $b8, $03, $8e, $1b
	.byte $02, $3b, $02, $0f, $08, $03, $10, $f7, $05, $6b
	.byte $85, $ff

E_D2:
	.byte $db, $82, $f3, $03, $10, $b7, $80, $37, $1a, $8e
	.byte $4b, $0e, $7a, $0e, $ab, $0e, $0f, $05, $f9, $0e
	.byte $d0, $be, $2e, $c1, $62, $d4, $8f, $64, $8f, $7e
	.byte $2b, $60, $ff

E_D3:
	.byte $0f, $03, $ab, $05, $1b, $85, $a3, $85, $d7, $05
	.byte $0f, $08, $33, $03, $0b, $85, $fb, $85, $8b, $85
	.byte $3a, $8e, $ff

E_D4_Outside:
	.byte $0f, $02, $09, $05, $3e, $41, $64, $2b, $8e, $58
	.byte $0e, $ca, $07, $34, $87, $ff

E_AD_Cloud:
	.byte $0a, $aa, $1e, $20, $03, $1e, $22, $27, $2e, $24
	.byte $48, $2e, $28, $67, $ff

E_A2:
	.byte $bb, $a9, $1b, $a9, $69, $29, $b8, $29, $59, $a9
	.byte $8d, $a8, $0f, $07, $15, $29, $55, $ac, $6b, $85
	.byte $0e, $ad, $01, $67, $34, $ff

E_AD_Bonus:
	.byte $1e, $a0, $09, $1e, $27, $67, $0f, $03, $1e, $28
	.byte $68, $0f, $05, $1e, $24, $48, $1e, $63, $68, $ff

E_B2:
	.byte $ee, $ad, $21, $26, $87, $f3, $0e, $66, $87, $cb
	.byte $00, $65, $87, $0f, $06, $06, $0e, $97, $07, $cb
	.byte $00, $75, $87, $d3, $27, $d9, $27, $0f, $09, $77
	.byte $1f, $46, $87, $b1, $0f, $ff

;Worlds A-D Area Data
L_A4:
	.byte $9b, $87, $05, $32, $06, $33, $07, $34, $ee, $0a
	.byte $0e, $86, $28, $0e, $3e, $0a, $6e, $02, $8b, $0e
	.byte $97, $00, $9e, $0a, $ce, $06, $e8, $0e, $fe, $0a
	.byte $2e, $86, $6e, $0a, $8e, $08, $e4, $0e, $1e, $82
	.byte $8a, $0e, $8e, $0a, $fe, $02, $1a, $e0, $29, $61
	.byte $2e, $06, $3e, $09, $56, $60, $65, $61, $6e, $0c
	.byte $83, $60, $7e, $8a, $bb, $61, $f9, $63, $27, $e5
	.byte $88, $64, $eb, $61, $fe, $05, $68, $90, $0a, $90
	.byte $fe, $02, $3a, $90, $3e, $0a, $ae, $02, $da, $60
	.byte $e9, $61, $f8, $62, $fe, $0a, $0d, $c4, $a1, $62
	.byte $b1, $62, $cd, $43, $ce, $09, $de, $0b, $dd, $42
	.byte $fe, $02, $5d, $c7, $fd

L_B4:
	.byte $9b, $07, $05, $32, $06, $33, $07, $33, $3e, $0a
	.byte $41, $3b, $42, $3b, $58, $64, $7a, $62, $c8, $31
	.byte $18, $e4, $39, $73, $5e, $09, $66, $3c, $0e, $82
	.byte $28, $07, $36, $0e, $3e, $0a, $ae, $02, $d7, $0e
	.byte $fe, $0c, $fe, $8a, $11, $e5, $21, $65, $31, $65
	.byte $4e, $0c, $fe, $02, $16, $8e, $2e, $0e, $fe, $02
	.byte $18, $fa, $3e, $0e, $fe, $02, $16, $8e, $2e, $0e
	.byte $fe, $02, $18, $fa, $3e, $0e, $fe, $02, $16, $8e
	.byte $2e, $0e, $fe, $02, $18, $fa, $3e, $0e, $fe, $02
	.byte $16, $8e, $2e, $0e, $fe, $02, $18, $fa, $5e, $0a
	.byte $6e, $02, $7e, $0a, $b7, $0e, $ee, $07, $fe, $8a
	.byte $0d, $c4, $cd, $43, $ce, $09, $dd, $42, $de, $0b
	.byte $fe, $02, $5d, $c7, $fd

L_C4:
	.byte $98, $07, $05, $35, $06, $3d, $07, $3d, $be, $06
	.byte $de, $0c, $f3, $3d, $03, $8e, $63, $0e, $6e, $43
	.byte $ce, $0a, $e1, $67, $f1, $67, $01, $e7, $11, $67
	.byte $1e, $05, $28, $39, $6e, $40, $be, $01, $c7, $06
	.byte $db, $0e, $de, $00, $1f, $80, $6f, $00, $bf, $00
	.byte $0f, $80, $5f, $00, $7e, $05, $a8, $37, $fe, $02
	.byte $24, $8e, $34, $30, $3e, $0c, $4e, $43, $ae, $0a
	.byte $be, $0c, $ee, $0a, $fe, $0c, $2e, $8a, $3e, $0c
	.byte $7e, $02, $8e, $0e, $98, $36, $b9, $34, $08, $bf
	.byte $09, $3f, $0e, $82, $2e, $86, $4e, $0c, $9e, $09
	.byte $a6, $60, $c1, $62, $c4, $0e, $ee, $0c, $0e, $86
	.byte $5e, $0c, $7e, $09, $86, $60, $a1, $62, $a4, $0e
	.byte $c6, $60, $ce, $0c, $fe, $0a, $28, $b4, $a6, $31
	.byte $e8, $34, $8b, $b2, $9b, $0e, $fe, $07, $fe, $8a
	.byte $0d, $c4, $cd, $43, $ce, $09, $dd, $42, $de, $0b
	.byte $fe, $02, $5d, $c7, $fd

L_D4:
	.byte $5b, $03, $05, $34, $06, $35, $39, $71, $6e, $02
	.byte $ae, $0a, $fe, $05, $17, $8e, $97, $0e, $9e, $02
	.byte $a6, $06, $fa, $30, $fe, $0a, $4e, $82, $57, $0e
	.byte $58, $62, $68, $62, $79, $61, $8a, $60, $8e, $0a
	.byte $f5, $31, $f9, $73, $39, $f3, $b5, $71, $b7, $31
	.byte $4d, $c8, $8a, $62, $9a, $62, $ae, $05, $bb, $0e
	.byte $cd, $4a, $fe, $82, $77, $fb, $de, $0f, $4e, $82
	.byte $6d, $47, $39, $f3, $0c, $ea, $08, $3f, $b3, $00
	.byte $cc, $63, $f9, $30, $69, $f9, $ea, $60, $f9, $61
	.byte $fe, $07, $de, $84, $e4, $62, $e9, $61, $f4, $62
	.byte $fa, $60, $04, $e2, $14, $62, $24, $62, $34, $62
	.byte $3e, $0a, $7e, $0c, $7e, $8a, $8e, $08, $94, $36
	.byte $fe, $0a, $0d, $c4, $61, $64, $71, $64, $81, $64
	.byte $cd, $43, $ce, $09, $dd, $42, $de, $0b, $fe, $02
	.byte $5d, $c7, $fd

L_A1:
	.byte $52, $71, $0f, $20, $6e, $70, $e3, $64, $fc, $61
	.byte $fc, $71, $13, $86, $2c, $61, $2c, $71, $43, $64
	.byte $b2, $22, $b5, $62, $c7, $28, $22, $a2, $52, $09
	.byte $56, $61, $6c, $03, $db, $71, $fc, $03, $f3, $20
	.byte $03, $a4, $0f, $71, $40, $0c, $8c, $74, $9c, $66
	.byte $d7, $01, $ec, $71, $89, $e1, $b6, $61, $b9, $2a
	.byte $c7, $26, $f4, $23, $67, $e2, $e8, $f2, $78, $82
	.byte $88, $01, $98, $02, $a8, $02, $b8, $02, $03, $a6
	.byte $07, $26, $21, $79, $4b, $71, $cf, $33, $06, $e4
	.byte $16, $2a, $39, $71, $58, $45, $5a, $45, $c6, $07
	.byte $dc, $04, $3f, $e7, $3b, $71, $8c, $71, $ac, $01
	.byte $e7, $63, $39, $8f, $63, $20, $65, $0b, $68, $62
	.byte $8c, $00, $0c, $81, $29, $63, $3c, $01, $57, $65
	.byte $6c, $01, $85, $67, $9c, $04, $1d, $c1, $5f, $26
	.byte $3d, $c7, $fd

L_A3:
	.byte $50, $50, $0b, $1f, $0f, $26, $19, $96, $84, $43
	.byte $b7, $1f, $5d, $cc, $6d, $48, $e0, $42, $e3, $12
	.byte $39, $9c, $56, $43, $47, $9b, $a4, $12, $c1, $06
	.byte $ed, $4d, $f4, $42, $1b, $98, $b7, $13, $02, $c2
	.byte $03, $12, $47, $1f, $ad, $48, $63, $9c, $82, $48
	.byte $76, $93, $08, $94, $8e, $11, $b0, $03, $c9, $0f
	.byte $1d, $c1, $2d, $4a, $4e, $42, $6f, $20, $0d, $0e
	.byte $0e, $40, $39, $71, $7f, $37, $f2, $68, $01, $e9
	.byte $11, $39, $68, $7a, $de, $1f, $6d, $c5, $fd

L_B1:
	.byte $52, $21, $0f, $20, $6e, $60, $6c, $f6, $ca, $30
	.byte $dc, $02, $08, $f2, $37, $04, $56, $74, $7c, $00
	.byte $dc, $01, $e7, $25, $47, $8b, $49, $20, $6c, $02
	.byte $96, $74, $06, $82, $36, $02, $66, $00, $a7, $22
	.byte $dc, $02, $0a, $e0, $63, $22, $78, $72, $93, $09
	.byte $97, $03, $a3, $25, $a7, $03, $b6, $24, $03, $a2
	.byte $5c, $75, $65, $71, $7c, $00, $9c, $00, $63, $a2
	.byte $67, $20, $77, $03, $87, $20, $93, $0a, $97, $03
	.byte $a3, $22, $a7, $20, $b7, $03, $bc, $00, $c7, $20
	.byte $dc, $00, $fc, $01, $19, $8f, $1e, $20, $46, $22
	.byte $4c, $61, $63, $00, $8e, $21, $d7, $73, $46, $a6
	.byte $4c, $62, $68, $62, $73, $01, $8c, $62, $d8, $62
	.byte $43, $a9, $c7, $73, $ec, $06, $57, $f3, $7c, $00
	.byte $b5, $65, $c5, $65, $dc, $00, $e3, $67, $7d, $c1
	.byte $bf, $26, $ad, $c7, $fd

L_B3:
	.byte $90, $10, $0b, $1b, $0f, $26, $07, $94, $bc, $14
	.byte $bf, $13, $c7, $40, $ff, $16, $d1, $80, $c3, $94
	.byte $cb, $17, $c2, $44, $29, $8f, $77, $31, $0b, $96
	.byte $76, $32, $c7, $75, $13, $f7, $1b, $61, $2b, $61
	.byte $4b, $12, $59, $0f, $3b, $b0, $3a, $40, $43, $12
	.byte $7a, $40, $7b, $30, $b5, $41, $b6, $20, $c6, $07
	.byte $f3, $13, $03, $92, $6b, $12, $79, $0f, $cc, $15
	.byte $cf, $11, $1f, $95, $c3, $14, $b3, $95, $a3, $95
	.byte $4d, $ca, $6b, $61, $7e, $11, $8d, $41, $be, $42
	.byte $df, $20, $bd, $c7, $fd

L_C1:
	.byte $52, $31, $0f, $20, $6e, $74, $0d, $02, $03, $33
	.byte $1f, $72, $39, $71, $65, $04, $6c, $70, $77, $01
	.byte $84, $72, $8c, $72, $b3, $34, $ec, $01, $ef, $72
	.byte $0d, $04, $ac, $67, $cc, $01, $cf, $71, $e7, $22
	.byte $17, $88, $23, $00, $27, $23, $3c, $62, $65, $71
	.byte $67, $33, $8c, $61, $dc, $01, $08, $fa, $45, $75
	.byte $63, $0a, $73, $23, $7c, $02, $8f, $72, $73, $a9
	.byte $9f, $74, $bf, $74, $ef, $73, $39, $f1, $fc, $0a
	.byte $0d, $0b, $13, $25, $4c, $01, $4f, $72, $73, $0b
	.byte $77, $03, $dc, $08, $23, $a2, $53, $09, $56, $03
	.byte $63, $24, $8c, $02, $3f, $b3, $77, $63, $96, $74
	.byte $b3, $77, $5d, $c1, $8f, $26, $7d, $c7, $fd

L_C2:
	.byte $54, $11, $0f, $26, $cf, $32, $f8, $62, $fe, $10
	.byte $3c, $b2, $bd, $48, $ea, $62, $fc, $4d, $fc, $4d
	.byte $17, $c9, $da, $62, $0b, $97, $b7, $12, $2c, $b1
	.byte $33, $43, $6c, $31, $ac, $41, $0b, $98, $ad, $4a
	.byte $db, $30, $27, $b0, $b7, $14, $c6, $42, $c7, $96
	.byte $d6, $44, $2b, $92, $39, $0f, $72, $41, $a7, $00
	.byte $1b, $95, $97, $13, $6c, $95, $6f, $11, $a2, $40
	.byte $bf, $15, $c2, $40, $0b, $9a, $62, $42, $63, $12
	.byte $ad, $4a, $0e, $91, $1d, $41, $4f, $26, $4d, $c7
	.byte $fd

L_C3:
	.byte $57, $11, $0f, $26, $fe, $10, $4b, $92, $59, $0f
	.byte $ad, $4c, $d3, $93, $0b, $94, $29, $0f, $7b, $93
	.byte $99, $0f, $0d, $06, $27, $12, $35, $0f, $23, $b1
	.byte $57, $75, $a3, $31, $ab, $71, $f7, $75, $23, $b1
	.byte $87, $13, $95, $0f, $0d, $0a, $23, $35, $38, $13
	.byte $55, $00, $9b, $16, $0b, $96, $c7, $75, $dd, $4a
	.byte $3b, $92, $49, $0f, $ad, $4c, $29, $92, $52, $40
	.byte $6c, $15, $6f, $11, $72, $40, $bf, $15, $03, $93
	.byte $0a, $13, $12, $41, $8b, $12, $99, $0f, $0d, $10
	.byte $47, $16, $46, $45, $b3, $32, $13, $b1, $57, $0e
	.byte $a7, $0e, $d3, $31, $53, $b1, $a6, $31, $03, $b2
	.byte $13, $0e, $8d, $4d, $ae, $11, $bd, $41, $ee, $52
	.byte $0f, $a0, $dd, $47, $fd

L_D1:
	.byte $52, $a1, $0f, $20, $6e, $65, $04, $a0, $14, $07
	.byte $24, $2d, $57, $25, $bc, $09, $4c, $80, $6f, $33
	.byte $a5, $11, $a7, $63, $b7, $63, $e7, $20, $35, $a0
	.byte $59, $11, $b4, $08, $c0, $04, $05, $82, $15, $02
	.byte $25, $02, $3a, $10, $4c, $01, $6c, $79, $95, $79
	.byte $73, $a7, $8f, $74, $f3, $0a, $03, $a0, $93, $08
	.byte $97, $73, $e3, $20, $39, $f1, $94, $07, $aa, $30
	.byte $bc, $5c, $c7, $30, $24, $f2, $27, $31, $8f, $33
	.byte $c6, $10, $c7, $63, $d7, $63, $e7, $63, $f7, $63
	.byte $03, $a5, $07, $25, $aa, $10, $03, $bf, $4f, $74
	.byte $6c, $00, $df, $74, $fc, $00, $5c, $81, $77, $73
	.byte $9d, $4c, $c5, $30, $e3, $30, $7d, $c1, $bd, $4d
	.byte $bf, $26, $ad, $c7, $fd

L_D2:
	.byte $55, $a1, $0f, $26, $9c, $01, $4f, $b6, $b3, $34
	.byte $c9, $3f, $13, $ba, $a3, $b3, $bf, $74, $0c, $84
	.byte $83, $3f, $9f, $74, $ef, $72, $ec, $01, $2f, $f2
	.byte $2c, $01, $6f, $72, $6c, $01, $a8, $91, $aa, $10
	.byte $03, $b7, $61, $79, $6f, $75, $39, $f1, $db, $71
	.byte $03, $a2, $17, $22, $33, $09, $43, $20, $5b, $71
	.byte $48, $8f, $4a, $30, $5c, $5c, $a3, $30, $2d, $c1
	.byte $5f, $26, $3d, $c7, $fd

L_D3:
	.byte $55, $a1, $0f, $26, $39, $91, $68, $12, $a7, $12
	.byte $aa, $10, $c7, $07, $e8, $12, $19, $91, $6c, $00
	.byte $78, $74, $0e, $c2, $76, $a8, $fe, $40, $29, $91
	.byte $73, $29, $77, $53, $8c, $77, $59, $91, $87, $13
	.byte $b6, $14, $ba, $10, $e8, $12, $38, $92, $19, $8f
	.byte $2c, $00, $33, $67, $4e, $42, $68, $0b, $2e, $c0
	.byte $38, $72, $a8, $11, $aa, $10, $49, $91, $6e, $42
	.byte $de, $40, $e7, $22, $0e, $c2, $4e, $c0, $6c, $00
	.byte $79, $11, $8c, $01, $a7, $13, $bc, $01, $d5, $15
	.byte $ec, $01, $03, $97, $0e, $00, $6e, $01, $9d, $41
	.byte $ce, $42, $ff, $20, $9d, $c7, $fd

L_D4_Outside:
	.byte $10, $21, $39, $f1, $09, $f1, $ad, $4c, $7c, $83
	.byte $96, $30, $5b, $f1, $c8, $05, $1f, $b7, $93, $67
	.byte $a3, $67, $b3, $67, $bd, $4d, $cc, $08, $54, $fe
	.byte $6e, $2f, $6d, $c7, $fd

L_AD_Cloud:
	.byte $00, $c1, $4c, $00, $02, $c9, $ba, $49, $62, $c9
	.byte $a4, $20, $a5, $20, $1a, $c9, $a3, $2c, $b2, $49
	.byte $56, $c2, $6e, $00, $95, $41, $ad, $c7, $fd

L_A2:
	.byte $48, $8f, $1e, $01, $4e, $02, $00, $8c, $09, $0f
	.byte $6e, $0a, $ee, $82, $2e, $80, $30, $20, $7e, $01
	.byte $87, $27, $07, $87, $17, $23, $3e, $00, $9e, $05
	.byte $5b, $f1, $8b, $71, $bb, $71, $eb, $71, $3e, $82
	.byte $7f, $38, $fe, $0a, $3e, $84, $47, $29, $48, $2e
	.byte $af, $71, $cb, $71, $e7, $0a, $f7, $23, $2b, $f1
	.byte $37, $51, $3e, $00, $6f, $00, $8e, $04, $df, $32
	.byte $9c, $82, $ca, $12, $dc, $00, $e8, $14, $fc, $00
	.byte $fe, $08, $4e, $8a, $88, $74, $9e, $01, $a8, $52
	.byte $bf, $47, $b8, $52, $c8, $52, $d8, $52, $e8, $52
	.byte $ee, $0f, $4d, $c7, $0d, $0d, $0e, $02, $68, $7a
	.byte $be, $01, $ee, $0f, $6d, $c5, $fd

L_AD_Bonus:
	.byte $08, $0f, $0e, $01, $2e, $05, $38, $20, $3e, $04
	.byte $48, $07, $55, $45, $57, $45, $58, $25, $b8, $08
	.byte $be, $05, $c8, $20, $ce, $01, $df, $4a, $6d, $c7
	.byte $0e, $81, $00, $5a, $2e, $02, $34, $42, $36, $42
	.byte $37, $22, $73, $54, $83, $0b, $87, $20, $93, $54
	.byte $90, $07, $b4, $41, $b6, $41, $b7, $21, $df, $4a
	.byte $6d, $c7, $0e, $81, $00, $5a, $14, $56, $24, $56
	.byte $2e, $0c, $33, $43, $6e, $09, $8e, $0b, $96, $48
	.byte $1e, $84, $3e, $05, $4a, $48, $47, $0b, $ce, $01
	.byte $df, $4a, $6d, $c7, $fd

L_B2:
	.byte $41, $01, $da, $60, $e9, $61, $f8, $62, $fe, $0b
	.byte $fe, $81, $47, $d3, $8a, $60, $99, $61, $a8, $62
	.byte $b7, $63, $c6, $64, $d5, $65, $e4, $66, $ed, $49
	.byte $f3, $67, $1a, $cb, $e3, $67, $f3, $67, $fe, $02
	.byte $31, $d6, $3c, $02, $77, $53, $ac, $02, $b1, $56
	.byte $e7, $53, $fe, $01, $77, $b9, $a3, $43, $00, $bf
	.byte $29, $51, $39, $48, $61, $55, $d2, $44, $d6, $54
	.byte $0c, $82, $2e, $02, $31, $66, $44, $47, $47, $32
	.byte $4a, $47, $97, $32, $c1, $66, $ce, $01, $dc, $02
	.byte $fe, $0e, $0c, $8f, $08, $4f, $fe, $02, $75, $e0
	.byte $fe, $01, $0c, $87, $9a, $60, $a9, $61, $b8, $62
	.byte $c7, $63, $ce, $0f, $d5, $0d, $6d, $ca, $7d, $47
	.byte $fd

;align to next $200 page (for some reason game does this with this file)
    .align $200
    
